<template>
  <v-dialog v-model="propDialog" persistent width="800px">
    <v-card>
      <v-card-title>
        <span class="headline">
          <v-icon color="info"> insert_drive_file </v-icon>
          รายละเอียดฟอร์ม
        </span>
        <v-spacer></v-spacer>
        <v-chip
          class="ma-2"
          :color="propObj | colorStatusRepair"
          label
          outlined
        >
          {{ propObj | statusRepair }}
        </v-chip>
      </v-card-title>
      <v-card-text>
        <v-container>
          <v-row>
            <v-col cols="12">
              <v-btn
                depressed
                color="success"
                small
                v-if="propObj.status == 'VF'"
                :disabled="cancel"
                @click="openDialog('approveAll')"
                >อนุมัติทั้งหมด
              </v-btn>
              <v-simple-table>
                <template v-slot:default>
                  <thead>
                    <tr>
                      <th class="text-left">ช่องล็อกเกอร์</th>
                      <th class="text-center">สถานะ</th>
                      <th class="text-center" v-if="propObj.status != 'VF'">
                        remark
                      </th>
                      <th
                        class="text-center"
                        v-if="propObj.status == 'VF' && role == 'Admin'"
                      >
                        action
                      </th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr
                      v-for="(item, index) in propObj.repairLkRoomList"
                      :key="index"
                    >
                      <td class="text-caption">{{ item.lkRoomCode }}</td>

                      <td class="text-caption text-center">
                        <span v-if="item.status == '-'">{{ item.status }}</span>
                        <v-chip
                          :color="item | colorStatusRepair"
                          dark
                          outlined
                          v-else
                        >
                          {{ item | statusRepair }}
                        </v-chip>
                      </td>
                      <td
                        class="text-caption text-center"
                        v-if="propObj.status != 'VF'"
                      >
                        <label v-if="item.remark != ''">{{
                          item.remark
                        }}</label>
                        <label v-else>-</label>
                      </td>
                      <td
                        class="text-caption text-center"
                        v-if="propObj.status == 'VF' && role == 'Admin'"
                      >
                        <v-icon
                          color="success"
                          text-color="white"
                          @click="openDialog('approveSome', item)"
                          v-show="
                            item.cancel == undefined || item.cancel == false
                          "
                          >mdi-checkbox-marked-circle</v-icon
                        >
                        <v-icon
                          color="red"
                          text-color="white"
                          @click="openDialog('rejectSome', item)"
                          v-show="
                            item.cancel == undefined || item.cancel == false
                          "
                        >
                          cancel
                        </v-icon>
                        <span
                          v-show="
                            item.cancel == true &&
                            item.remark != undefined &&
                            item.remark != ''
                          "
                        >
                          เหตุผล: {{ item.remark }}
                        </span>

                        <v-btn
                          dark
                          small
                          @click="cancelSome(item)"
                          v-show="item.cancel == true"
                          depressed
                          color="orange"
                          >ยกเลิก</v-btn
                        >
                      </td>
                    </tr>
                  </tbody>
                </template>
              </v-simple-table>
            </v-col>
          </v-row>
        </v-container>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="success darken-1"
          v-if="propObj.status == 'VF' && role == 'Admin'"
          text
          @click="openDialog('approveForm')"
        >
          ยืนยันแบบฟอร์ม
        </v-btn>
        <v-btn
          color="success darken-1"
          v-if="propObj.status == 'P' && role == 'Admin'"
          text
          @click="appvove('finish')"
        >
          อนุมัติการซ่อมเสร็จสิ้น
        </v-btn>
        <v-btn color="info darken-1" text @click="closeDialog"> ปิด </v-btn>
      </v-card-actions>
    </v-card>
    <DialogConfirm
      :dialog="dialogConfirm"
      v-model="remark"
      :title="objDialog.title"
      :status="status"
    >
      <template v-slot:confirm>
        <v-btn
          color="success"
          text
          :disabled="loading"
          :loading="loading"
          @click="
            status == 'reject'
              ? rejectSome()
              : status == 'approve'
              ? approveSome()
              : status == 'approveAll'
              ? approveAll()
              : status == 'approveForm'
              ? appvove()
              : null
          "
        >
          ใช่
        </v-btn>
      </template>
      <template v-slot:close>
        <v-btn color="error" text :disabled="loading" @click="close">
          ไม่ใช่
        </v-btn>
      </template>
    </DialogConfirm>
  </v-dialog>
</template>

<script>
import DialogConfirm from "../dialog/DialogConfirm";
import DialogRemark from "../dialog/DialogRemark";
export default {
  props: ["propObj", "propDialog"],
  components: { DialogConfirm, DialogRemark },
  data() {
    return {
      dialogRemark: false,
      rules: [(v) => v.length <= 50 || "ไม่เกิน 50 ตัวอักษร"],
      role: this.$store.getters["auth/roleUser"],
      singleSelect: false,
      dialogConfirm: false,
      loading: false,
      objDialog: {},
      selected: [],
      statusReject: "",
      status: "",
      remark: "",
      cancel: false,
      objDetail: {},
      headers: [
        {
          text: "ช่องล็อกเกอร์",
          align: "start",
          sortable: false,
          value: "lkRoomCode",
        },
        { text: "สถานะ", align: "center", sortable: false, value: "status" },
      ],
    };
  },
  methods: {
    close() {
      this.dialogConfirm = false;
    },
    closeDialog() {
      this.$emit("update:close", false);
      if (this.propObj.status == "VF") {
        for (let i in this.propObj.repairLkRoomList) {
          this.propObj.repairLkRoomList[i].status = "-";
          this.propObj.repairLkRoomList[i].cancel = false;
          this.propObj.repairLkRoomList[i].remark = "";
        }
        this.cancel = false;
      }
    },
    openDialog(status, item) {
      if (status == "rejectSome") {
        this.dialogConfirm = true;
        this.objDialog.title = "คุณต้องการไม่อนุมัติช่องนี้เพราะ";
        this.status = "reject";
        this.objDetail = item;
      } else if (status == "approveSome") {
        this.dialogConfirm = true;
        this.objDialog.title = "คุณต้องการอนุมัติหรือไม่";
        this.status = "approve";
        this.objDetail = item;
      } else if (status == "approveForm") {
        this.dialogConfirm = true;
        this.objDialog.title = "คุณต้องการยืนยันฟอร์มหรือไม่";
        this.status = "approveForm";
      } else if (status == "approveAll") {
        this.dialogConfirm = true;
        this.objDialog.title = "คุณต้องการอนุมัติทั้งหมดหรือไม่";
        this.status = "approveAll";
      }
    },
    cancelSome(item) {
      for (let i in this.propObj.repairLkRoomList) {
        if (this.propObj.repairLkRoomList[i].lkRoomCode == item.lkRoomCode) {
          this.propObj.repairLkRoomList[i].status = "-";
          this.propObj.repairLkRoomList[i].cancel = undefined;
          this.propObj.repairLkRoomList[i].remark = "";
        }
      }
      this.cancel = false;
    },
    rejectSome() {
      for (let i in this.propObj.repairLkRoomList) {
        if (
          this.propObj.repairLkRoomList[i].lkRoomCode ==
          this.objDetail.lkRoomCode
        ) {
          this.propObj.repairLkRoomList[i].status = "R";
          this.propObj.repairLkRoomList[i].cancel = true;
          this.propObj.repairLkRoomList[i].remark = this.remark;
        }
      }
      this.remark = "";
      this.dialogConfirm = false;
      this.cancel = true;
    },
    approveAll() {
      for (let i in this.propObj.repairLkRoomList) {
        this.propObj.repairLkRoomList[i].status = "P";
        this.propObj.repairLkRoomList[i].cancel = true;
        this.propObj.repairLkRoomList[i].remark = "";
      }
      this.dialogConfirm = false;
      this.cancel = true;
    },
    approveSome() {
      for (let i in this.propObj.repairLkRoomList) {
        if (
          this.propObj.repairLkRoomList[i].lkRoomCode ==
          this.objDetail.lkRoomCode
        ) {
          this.propObj.repairLkRoomList[i].status = "P";
          this.propObj.repairLkRoomList[i].cancel = true;
          this.propObj.repairLkRoomList[i].remark = "";
        }
      }
      this.dialogConfirm = false;
    },
    async appvove(status) {
      var data;
      // let length = this.propObj.repairLkRoomList.length;
      let StatusP = this.propObj.repairLkRoomList.filter(
        (s) => s.status == "P"
      );

      let valid = this.propObj.repairLkRoomList.filter((s) => s.status == "-");
      this.loading = true;
      if (StatusP.length != 0) {
        data = {
          repairFormId: this.propObj.repairFormId,
          status: "P",
          repairLkRoomList: this.propObj.repairLkRoomList,
        };
      } else if (status == "finish") {
        data = {
          repairFormId: this.propObj.repairFormId,
        };
      } else if (StatusP == 0) {
        data = {
          repairFormId: this.propObj.repairFormId,
          status: "R",
          remark: "",
          repairLkRoomList: this.propObj.repairLkRoomList,
        };
      }
      if (valid.length == 0) {
        if (status == "finish")
          await this.$store.dispatch("repair/approveFinish", data);
        else await this.$store.dispatch("repair/approve", data);

        let error = this.$store.getters["repair/error"];
        if (error === false) {
          await this.$store.dispatch("snackbar/showSnack", {
            text: "ดำเนินการสำเร็จ",
            color: "success",
            timeout: 3000,
          });
          this.dialogConfirm = false;
          this.loading = false;
          this.$emit("update:close", false);
          this.$emit("update-table", true);
        } else {
          await this.$store.dispatch("snackbar/showSnack", {
            text: "ข้อมูลจากระบบผิดพลาด!",
            color: "red",
            timeout: 3000,
          });
          this.dialogConfirm = false;
          this.loading = false;
        }
      }
      else{
         await this.$store.dispatch("snackbar/showSnack", {
            text: "กรุณาเลือกช่องล็อกเกอร์ให้ครบ!",
            color: "red",
            timeout: 4000,
          });
          this.dialogConfirm = false;
          this.loading = false;
      }
    },
  },
};
</script>

<style>
</style>